<?php
namespace Claromentis\Core\Acl\Simple;

$GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"] = (@$GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"] ?: array()) + array("_80fc2a45acd0150df87d1fb" . "728940a60" => base64_decode("U0VMRUNUIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wgV0hFUkUgb2JqZWN0X2NvZGUgZXE6c3RyOmNvZ" . "GUgQU5EIHVzZXJfaWQ9aW50OnVpZA=="), "_a7ed4d7408bb99" . "b87a09d89d4212d" . "5de" => base64_decode("c2ltcGxlX2" . "FjbA=="), "_ef2948c87" . "ef38aab922" . "6e41189b29" . "ca7" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbC" . "BXSEVSRSBvYmplY3RfY29kZSBlcTpz" . "dHI6Y29kZQ=="), "_a8b22fedb27a1" . "1e07f5bb9a7c73" . "608ea" => base64_decode("c3RyKDEwMCk" . "6b2JqZWN0X2" . "NvZGU="), "_938704c4c0169c3804d" . "4bd6aa9941a76" => base64_decode("Q2FuJ3QgbG9hZCBBQ0w6IG9iamVjdCBjb2RlIG5vd" . "CBzcGVjaWZpZWQ="), "_dbbe14f567693a6" . "31f8a43b65af917a" . "b" => base64_decode("Q2FuJ3QgZGVsZXRlIEFDTCBmcm9tIGRhdGFiYXNlOiBvYm" . "plY3QgY29kZSBub3Qgc3BlY2lmaWVk"), "_27de5a45db71bf24058769b61" . "b3975a3" => base64_decode("Q2FuJ3Qgc2F2ZSBBQ0w6IG9iamVjdCBjb2RlIG5vdCB" . "zcGVjaWZpZWQ="), "_3cda3f34ada928e" . "4aa39d4629c5504a" . "a" => base64_decode("aW50OnJpZ" . "2h0cw=="), "_c95cbc31617" . "8c97697a403f" . "4d9124106" => base64_decode("U0VMRUNUIHVzZXJfaWQsIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wgV0hFUkUgb2JqZWN0X2NvZGUgZXE6c3RyOmNvZGU" . "="), "_b06968b9268d" . "eaf3b380bd0fe" . "922b453" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCBXSEVSRSBvYmplY3" . "RfY29kZSBlcTpzdHI6Y29kZSBBTkQgdXNlcl9pZD1pbnQ6" . "dWlk"), "_0877a0b48cf" . "424a0de57a45" . "3ce95e30c" => base64_decode("aW50" . "OnVz" . "ZXJf" . "aWQ="), "_84718d828d2acc3c366f9" . "6b07e841f6a" => base64_decode("YWNsLnN" . "pbXBsZQ" . "=="));
use Claromentis\Core\Acl\Exception\NoObjectException;
use Claromentis\Core\DAL;





class SimpleAclRepository
{
    private $db;
    public function __construct(DAL\Db $db)
    {
        $this->db = $db;
    }
    
    
    
    
    public static function I()
    {
        global $g_application;
        return $g_application[$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_84718d8" . "28d2acc3" . "c366f96b" . "07e841f6" . "a"]];
    }
    public function IsGranted(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD) : bool
    {
        if (!$user_id) {
            return false;
        }
        
        
        
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_80fc2a45acd0150df87" . "d1fb728940a60"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
        if (!$_1f24efd4735b7a11b391147435e7d35d->hasData()) {
            return false;
        }
        list($p) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow();
        return ($p & $perms) == $perms;
    }
    public function Grant(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD)
    {
        $this->db->query(new DAL\QueryInsert($GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_a7ed4d7408b" . "b99b87a09d89" . "d4212d5de"], [$GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_a8b22fed" . "b27a11e07" . "f5bb9a7c7" . "3608ea"] => $_65c616d6ef3c21352d2d44595fdf776b, $GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_0877a0b48cf424a0de57a453ce" . "95e30c"] => $user_id, $GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_3cda3f34ad" . "a928e4aa39d" . "4629c5504aa"] => $perms]));
    }
    public function Revoke(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id)
    {
        $this->db->query($GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_b06968b9268deaf3b380bd0fe922b45" . "3"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
    }
    
    
    
    
    
    
    
    
    public function Get(string $_65c616d6ef3c21352d2d44595fdf776b) : SimpleAcl
    {
        $acl = new SimpleAcl($_65c616d6ef3c21352d2d44595fdf776b);
        $this->Load($acl);
        return $acl;
    }
    
    
    
    
    
    
    public function Load(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_938704c4c016" . "9c3804d4bd6aa" . "9941a76"]);
        }
        $acl->Clear();
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_c95cbc316178c97697a403f4d912" . "4106"], $acl->GetObjectCode());
        while (list($user_id, $perms) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow()) {
            $acl->Set($user_id, $perms);
        }
    }
    
    
    
    
    public function Save(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_27de5a45db71bf24058769b61b3" . "975a3"]);
        }
        $this->Delete($acl);
        $_65c616d6ef3c21352d2d44595fdf776b = $acl->GetObjectCode();
        foreach ($acl->GetRights() as $user_id => $perms) {
            if ($perms) {
                $this->Grant($_65c616d6ef3c21352d2d44595fdf776b, $user_id, $perms);
            }
        }
    }
    
    
    
    
    
    
    public function Delete(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_dbbe14f567693a631f8a43b65af" . "917ab"]);
        }
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_ef2948c87ef38a" . "ab9226e41189b29" . "ca7"], $acl->GetObjectCode());
    }
}